// test the listbox creation and selection
// modified from BCX generated C code for Dev-C++
// a Dev-C++ tested Windows Application by  vegaseat  04nov2004

#include <windows.h>
#include <stdio.h>


#define IDC_BOX1        101             // first check box 
#define IDC_BOX2        102             // second check box


static HINSTANCE BCX_hInstance;
static int     BCX_ScaleX;
static int     BCX_ScaleY;
static char    BCX_ClassName[2048];  // default size
static char    text[2048];
static HWND    Form1;
static HWND    List1;

#define Show(Window)  RedrawWindow(Window,0,0,0);ShowWindow(Window,SW_SHOW);

HWND    BCX_Form(char*,int=0,int=0,int=250,int=150,int=0,int=0);
HWND    BCX_Listbox(char*,HWND,int,int,int,int,int,int=0,int=-1);
void    Center (HWND,HWND=0,HWND=0);
char*   BCX_TmpStr(size_t);
void SetFont(HWND hwnd,LPTSTR FontName,int FontSize);

void    FormLoad (void);
LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);
void    addLB (HWND, char *);
char    * getLB (HWND);
int DrawTriangle(HWND hdc);

// sample data for the list box
static char names[7][10]=
{
        "Heidi", "Bertha", "Samantha", "Rubin",
        "Frank", "Sandy", "Sunny"
};
HBITMAP hbm1; //  = LoadBitmap(BCX_hInstance, "bmp00001.bmp"); 
HBITMAP hbm2; //  = LoadBitmap(BCX_hInstance, "bmp00002.bmp"); 


// this is the standard windows main() function
int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrev,LPSTR CmdLine,int CmdShow)
{
        WNDCLASS Wc;
        MSG      Msg;
        // *****************************
        strcpy(BCX_ClassName,"ListBox1");
        // ***************************************
        // Programmer has selected to use pixels
        // ***************************************
        BCX_ScaleX       = 1;          // for generic scaling
        BCX_ScaleY       = 1;
        BCX_hInstance    =  hInst;
        // ******************************************************
        Wc.style         =  CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
        Wc.lpfnWndProc   =  WndProc;
        Wc.cbClsExtra    =  0;
        Wc.cbWndExtra    =  0;
        Wc.hInstance     =  hInst;
        Wc.hIcon         =  LoadIcon(NULL,IDI_WINLOGO);
        Wc.hCursor       =  LoadCursor(NULL,IDC_ARROW);
        Wc.hbrBackground =  (HBRUSH)(COLOR_BTNFACE+1);
        Wc.lpszMenuName  =  NULL;
        Wc.lpszClassName =  BCX_ClassName;
        RegisterClass(&Wc);

        FormLoad();
        // the event message loop
        while(GetMessage(&Msg,NULL,0,0))
        {
                // HWND hActiveWindow = GetActiveWindow();
                // if (!IsWindow(hActiveWindow) || !IsDialogMessage(hActiveWindow,&Msg))
                {
                        TranslateMessage(&Msg);
                        DispatchMessage(&Msg);
                }
        }
        return Msg.wParam;
}


// circular storage for strings
char *BCX_TmpStr (size_t Bites)
{
        static int   StrCnt;
        static char *StrFunc[2048];
        StrCnt=(StrCnt + 1) & 2047;
        if(StrFunc[StrCnt]) free (StrFunc[StrCnt]);
        return StrFunc[StrCnt]=(char*)calloc(Bites+128,sizeof(char));
}


// center the form in the screen (really optional, for looks)
void Center (HWND hwnd, HWND Xhwnd, HWND Yhwnd)
{
        RECT rect, rectP;
        int  x, y, width, height;
        int  screenwidth, screenheight;
        if(Xhwnd==0)
        {
                RECT  DesktopArea;
                RECT  rc;
                SystemParametersInfo(SPI_GETWORKAREA,0,&DesktopArea,0);
                GetWindowRect(hwnd,&rc);
                SetWindowPos(hwnd,HWND_TOP,
                ((DesktopArea.right-DesktopArea.left)-(rc.right-rc.left))/2+
                DesktopArea.left,((DesktopArea.bottom-DesktopArea.top)-
                (rc.bottom-rc.top))/2 + DesktopArea.top,0,0,SWP_NOSIZE);
                return;
        }
        GetWindowRect (hwnd,&rect);
        GetWindowRect (Xhwnd,&rectP);
        width = rect.right-rect.left;
        x = ((rectP.right-rectP.left)-width)/2 + rectP.left;
        if(Yhwnd==NULL)
        {
                height = rect.bottom-rect.top;
                y = ((rectP.bottom-rectP.top)-height)/2 + rectP.top;
        }
        else
        {
                GetWindowRect(Yhwnd,&rectP);
                height = rect.bottom-rect.top;
                y = ((rectP.bottom-rectP.top)-height)/2+rectP.top;
        }
        screenwidth = GetSystemMetrics(SM_CXSCREEN);
        screenheight = GetSystemMetrics(SM_CYSCREEN);
        if ((x<0)) x=0;
        if ((y<0)) y=0;
        if ((x+width>screenwidth))   x = screenwidth-width;
        if ((y+height>screenheight)) y = screenheight-height;
        MoveWindow (hwnd, x, y, width, height, FALSE);
}


// create the windows form
HWND BCX_Form(char *Caption, int X, int Y, int W, int H, int Style, int Exstyle)
{
        HWND  A;
        // assign a default style
        if (!Style)
        {
                Style= WS_MINIMIZEBOX  |
                WS_SIZEBOX      |
                WS_CAPTION      |
                WS_MAXIMIZEBOX  |
                WS_POPUP        |
                WS_SYSMENU;
        }
        A = CreateWindowEx(Exstyle,BCX_ClassName,Caption,
        Style,
        X*BCX_ScaleX,
        Y*BCX_ScaleY,
        (4+W)*BCX_ScaleX,
        (12+H)*BCX_ScaleY,
        NULL,(HMENU)NULL,BCX_hInstance,NULL);
        SendMessage(A,(UINT)WM_SETFONT,(WPARAM)GetStockObject(DEFAULT_GUI_FONT),
        (LPARAM)MAKELPARAM(FALSE,0));

        return A;
}

HFONT BCX_Set_Font (char *Font,int Size,int Bold,int Italic,int Underline,int StrikeThru)
{
        HDC hDC = GetDC(HWND_DESKTOP);
        int CyPixels = GetDeviceCaps(hDC,LOGPIXELSY);
        ReleaseDC(HWND_DESKTOP,hDC);
        return CreateFont(0-(Size*CyPixels)/72,0,0,0,Bold,Italic,Underline,StrikeThru,
        0,OUT_TT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,FF_DONTCARE,Font);
}



// create the list box with desired styles
HWND BCX_Listbox
(char* Text,HWND hWnd,int id,int X,int Y,int W,int H,int Style,int Exstyle)
{
        HWND  A,B, C, D;

        // assign a default style if needed
        if (!Style)
        {
                Style=LBS_STANDARD | WS_CHILD | WS_VISIBLE |
                LBS_SORT | WS_VSCROLL | WS_TABSTOP;
        }
        if (Exstyle == -1)
        {
                Exstyle=WS_EX_CLIENTEDGE;
        }
        A = CreateWindowEx(Exstyle,"Listbox",NULL,Style,
        X*BCX_ScaleX, Y*BCX_ScaleY, W*BCX_ScaleX, H*BCX_ScaleY,
        hWnd,(HMENU)id,BCX_hInstance,NULL);

#define MIXER_ORIG_X	(130)
#define MIXER_ORIG_Y	(100)
#define MIXER_SIZE	(22)

	B = CreateWindow("BUTTON","+",
		WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON, // | WS_THICKFRAME,
	       	MIXER_ORIG_X,
	       	MIXER_ORIG_Y,
	       	MIXER_SIZE,
	       	MIXER_SIZE,
		hWnd,
		(HMENU)IDC_BOX1,
		BCX_hInstance,
		NULL);

	C = CreateWindow("BUTTON","-",
		WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON, // | WS_THICKFRAME,
	       	MIXER_ORIG_X,
	       	MIXER_ORIG_Y + MIXER_SIZE,
	       	MIXER_SIZE,
	       	MIXER_SIZE,
		hWnd,
		(HMENU)IDC_BOX2,
		(HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
		NULL);


	D = CreateWindowEx(Exstyle,"Edit","100",
		WS_VISIBLE | WS_CHILD | ES_READONLY | ES_CENTER | ES_NUMBER | ES_NOHIDESEL     ,
	       	MIXER_ORIG_X + MIXER_SIZE,
	       	MIXER_ORIG_Y,
	       	70,
	       	MIXER_SIZE * 2,
		hWnd,(HMENU)id,BCX_hInstance,NULL);

	SendMessage(D,(UINT)WM_SETFONT,(WPARAM)BCX_Set_Font("Verdana",22,1,0,0,0),1);
	// SendMessageLong(WndProcD,C,(WPARAM)BCX_Set_Font("Verdana",36,1,0,0,0),1);
	//
	//
	
        // HDC hDC = GetDC(HWND_DESKTOP);


	TCHAR    szFileNamep[_MAX_PATH];


	strcpy(szFileNamep, "D:\\CIUFFOLI\\sample\\test8a\\bmp00001.bmp"); 

        hbm1 = (HBITMAP)LoadImage(BCX_hInstance, szFileNamep, IMAGE_BITMAP, 0, 0,
		LR_LOADFROMFILE | LR_CREATEDIBSECTION | LR_DEFAULTSIZE);

	if (!hbm1)
	{
	    MessageBox(hWnd, szFileNamep,  "Open failed", MB_OK);
	}

	strcpy(szFileNamep, "bmp00002.bmp"); 

        hbm2 = (HBITMAP)LoadImage(BCX_hInstance, szFileNamep, IMAGE_BITMAP, 0, 0,
		LR_LOADFROMFILE | LR_CREATEDIBSECTION | LR_DEFAULTSIZE);
	

	if (!hbm2)
	{
	    MessageBox(hWnd, szFileNamep,  "Open failed", MB_OK);
	    return 0;
	}

	

	

        return A;
}


// the details for Form1 and List1 (corner,width,height)
void FormLoad (void)
{
        static char A[2048];
        memset(&A,0,sizeof(A));
        static int      k;
        memset(&k,0,sizeof(k));
        Form1=BCX_Form("Click on a name ...",0,0,360,300);
        List1=BCX_Listbox("",Form1,1009,10,15,100,150);
        for(k=0; k<=6; k+=1)
        {
                strcpy(A,(char*)names[k]);
                addLB(List1,A);
        }
        Center(Form1);   // optional
        Show(Form1);
}


// standard windows message handling
LRESULT CALLBACK WndProc (HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	HDC hdcMem; 
	LPDRAWITEMSTRUCT lpdis;
	char tmp[200];


	if (Msg == WM_DRAWITEM) 
	{
		lpdis = (LPDRAWITEMSTRUCT) lParam; 

		hdcMem = CreateCompatibleDC(lpdis->hDC); 

		if (lpdis->itemState & ODS_SELECTED)  // if selected 
			SelectObject(hdcMem, hbm2); 
		else 
			SelectObject(hdcMem, hbm1); 
		
		
		StretchBlt( lpdis->hDC,
			       	lpdis->rcItem.left,
			       	lpdis->rcItem.top,
			       	lpdis->rcItem.right - lpdis->rcItem.left,
			       	lpdis->rcItem.bottom - lpdis->rcItem.top,
			       	hdcMem, 0, 0, 19, 19, SRCCOPY);  

		DeleteDC(hdcMem); 

		return TRUE;
	}

	if (Msg==WM_NOTIFY)
	{
		MessageBox(hWnd, "WM_NOTIFY",  "Debug", MB_OK);
		return 0;
	}
	if (Msg==WM_KEYDOWN)
	{
		MessageBox(hWnd, "WM_NOTIFY",  "Debug", MB_OK);
		return 0;
	}
	if (Msg==WM_LBUTTONDOWN)
	{
		MessageBox(hWnd, "WM_LBUTTONDOWN",  "Debug", MB_OK);
		return 0;
	}

	if (Msg==WM_COMMAND)
	{
		if (HIWORD(wParam) == BN_CLICKED) 
                {
			MessageBox(hWnd, "BN_CLICKED",  "Debug", MB_OK);

			sprintf(tmp, "BN_CLICKED = %d\n", LOWORD(wParam));

			MessageBox(hWnd, tmp,  "Debug", MB_OK);

			// switch (LOWORD(wParam)) 
                        // {
				// case 101:
			// }
			
			return 0;
		}
		
		if (wParam==WM_LBUTTONDOWN)
		{
			MessageBox(hWnd, "WM_LBUTTONDOWN",  "Debug", MB_OK);
			return 0;
		}

		return 0;
	}
        if (Msg==WM_DESTROY)
	{
	     KillTimer(hWnd, 1); 
             PostQuitMessage(0);
	     exit(0);
	}
        return DefWindowProc(hWnd,Msg,wParam,lParam);
}


//  add a string to the listbox
void addLB (HWND idnr, char *ltext)
{
        SendMessage(idnr,(UINT)LB_ADDSTRING,(WPARAM)0,(LPARAM)ltext);
}

//  return selected listbox string
char * getLB (HWND idnr)
{
        static int      index;
        memset(&index,0,sizeof(index));
        static char buf[2048];
        memset(&buf,0,sizeof(buf));
        char *BCX_RetStr={0};
        index=SendMessage(idnr,(UINT)LB_GETCURSEL,(WPARAM)0,(LPARAM)0);
        SendMessage(idnr,(UINT)LB_GETTEXT,(WPARAM)index,(LPARAM)buf);
        BCX_RetStr=BCX_TmpStr(strlen(buf));
        strcpy(BCX_RetStr,buf);
        return BCX_RetStr;
}


int DrawTriangle(HWND hwnd)
{
    TRIVERTEX        vert [4] ;
    GRADIENT_TRIANGLE    gTri[2];

    vert[0].x       =  0;
    vert[0].y       =  0;
    vert[0].Red     =  0x0000;
    vert[0].Green   =  0x0000;
    vert[0].Blue    =  0x0000;
    vert[0].Alpha   =  0x0000;

    vert[1].x       =  100;
    vert[1].y       =  0;
    vert[1].Red     =  0x0000;
    vert[1].Green   =  0x0000;
    vert[1].Blue    =  0xff00;
    vert[1].Alpha   =  0x0000;

    vert[2].x       =  100;
    vert[2].y       =  32; 
    vert[2].Red     =  0x0000;
    vert[2].Green   =  0x0000;
    vert[2].Blue    =  0xff00;
    vert[2].Alpha   =  0x0000;

    vert[3].x       =  0;
    vert[3].y       =  32;
    vert[3].Red     =  0xff00;
    vert[3].Green   =  0xff00;
    vert[3].Blue    =  0xff00;
    vert[3].Alpha   =  0x0000;

    gTri[0].Vertex1   = 0;
    gTri[0].Vertex2   = 1;
    gTri[0].Vertex3   = 2;

    gTri[1].Vertex1   = 0;
    gTri[1].Vertex2   = 2;
    gTri[1].Vertex3   = 3;

HDC hdc = GetDC(HWND_DESKTOP);

    // GradientFill(hdc,vert,4,&gTri,1,GRADIENT_FILL_TRIANGLE);

    return 0;
}
	    
