#include <windows.h>
#include <stdio.h>

LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);


//**************************************************************************
// JOG DEFINE SECTION
//**************************************************************************
HWND 	      ButtonUp;
HWND 	      ButtonDown;
HWND 	      ButtonRight;
HWND 	      ButtonLeft;
HWND 	      ButtonCenter;
HBITMAP       hBitmapButtonUp;
HBITMAP       hBitmapButtonUpSel;
HBITMAP       hBitmapButtonDown;
HBITMAP       hBitmapButtonDownSel;
HBITMAP       hBitmapButtonRight;
HBITMAP       hBitmapButtonRightSel;
HBITMAP       hBitmapButtonLeft;
HBITMAP       hBitmapButtonLeftSel;
HBITMAP       hBitmapButtonCenter;
HBITMAP       hBitmapButtonCenterSel;
HPALETTE      hPalette;

#define EV_BUTTONRIGHT  (101)
#define EV_BUTTONLEFT   (102)
#define EV_BUTTONUP     (103)
#define EV_BUTTONDOWN   (104)
#define EV_BUTTONCENTER (105)

int CreateJog(HWND hMain, HINSTANCE hinstance);
BOOL LoadBitmapFromBMPFile( LPTSTR szFileName, HBITMAP *phBitmap, HPALETTE *phPalette );
int ChangeButton(LPDRAWITEMSTRUCT lpdis, HBITMAP hButton, HBITMAP hButtonSel);

//************************************************************************************



int WINAPI WinMain(HINSTANCE hinstance,HINSTANCE hPrev,LPSTR CmdLine,int CmdShow)
{
        WNDCLASS Wc;
        MSG      Msg;


        Wc.style         =  CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
        Wc.lpfnWndProc   =  WndProc;
        Wc.cbClsExtra    =  0;
        Wc.cbWndExtra    =  0;
        Wc.hInstance     =  hinstance;
        Wc.hIcon         =  NULL;
        Wc.hCursor       =  LoadCursor(NULL, IDC_ARROW);
        Wc.hbrBackground =  CreateSolidBrush(RGB(39,204, 66));
        Wc.lpszMenuName  =  NULL;
        Wc.lpszClassName =  "MaWinClass";

        RegisterClass(&Wc);


        HWND A = CreateWindow("MaWinClass", "test beta",
			   WS_OVERLAPPEDWINDOW|WS_VISIBLE,
			   // WS_VISIBLE|WS_EX_CLIENTEDGE|WS_EX_TOOLWINDOW,
			   CW_USEDEFAULT,
			   CW_USEDEFAULT,
			   600,
			   600,       
			   NULL,
			   NULL,
			   hinstance,
			   NULL);

	CreateJog(A, hinstance);

        while(GetMessage(&Msg,NULL,0,0))
        {
		TranslateMessage(&Msg);
		DispatchMessage(&Msg);
        }
        return Msg.wParam;
}

int CreateJog(HWND hMain, HINSTANCE hinstance)
{
#define JOG_ORIG_X	(80)
#define JOG_ORIG_Y	(80)
#define JOG_QUAD_SIZE	(80)
#define JOG_SHIFT	(0)

    ButtonCenter = CreateWindow("BUTTON","+",
	WS_VISIBLE|WS_CHILD|BS_DEFPUSHBUTTON|BS_PUSHBUTTON|BS_OWNERDRAW|BS_FLAT,
	JOG_ORIG_X + JOG_QUAD_SIZE + JOG_SHIFT,
	JOG_ORIG_Y + JOG_QUAD_SIZE + JOG_SHIFT,
	JOG_QUAD_SIZE,
	JOG_QUAD_SIZE,
	hMain,
	(HMENU)EV_BUTTONCENTER,hinstance, NULL);

    ButtonRight = CreateWindow("BUTTON","+",
	WS_VISIBLE|WS_CHILD|BS_DEFPUSHBUTTON|BS_PUSHBUTTON|BS_OWNERDRAW|BS_FLAT,
	JOG_ORIG_X + 2 * JOG_QUAD_SIZE + 2 * JOG_SHIFT,
	JOG_ORIG_Y + JOG_QUAD_SIZE + JOG_SHIFT,
	JOG_QUAD_SIZE,
	JOG_QUAD_SIZE,
	hMain,
	(HMENU)EV_BUTTONRIGHT,hinstance,NULL);

    ButtonLeft = CreateWindow("BUTTON","+",
	WS_VISIBLE|WS_CHILD|BS_DEFPUSHBUTTON|BS_PUSHBUTTON|BS_OWNERDRAW|BS_FLAT,
	JOG_ORIG_X,
	JOG_ORIG_Y + JOG_QUAD_SIZE + JOG_SHIFT,
	JOG_QUAD_SIZE,
	JOG_QUAD_SIZE,
	hMain,
	(HMENU)EV_BUTTONLEFT, hinstance, NULL);

    ButtonUp = CreateWindow("BUTTON","+",
	WS_VISIBLE|WS_CHILD|BS_DEFPUSHBUTTON|BS_PUSHBUTTON|BS_OWNERDRAW|BS_FLAT,
	JOG_ORIG_X + JOG_QUAD_SIZE + JOG_SHIFT,
	JOG_ORIG_Y,
	JOG_QUAD_SIZE,
	JOG_QUAD_SIZE,
	hMain,
	(HMENU)EV_BUTTONUP, hinstance, NULL);

    ButtonDown = CreateWindow("BUTTON","+",
	WS_VISIBLE|WS_CHILD|BS_DEFPUSHBUTTON|BS_PUSHBUTTON|BS_OWNERDRAW|BS_FLAT,
	JOG_ORIG_X + JOG_QUAD_SIZE + JOG_SHIFT,
	JOG_ORIG_Y + 2 * JOG_QUAD_SIZE + 2 * JOG_SHIFT,
	JOG_QUAD_SIZE,
	JOG_QUAD_SIZE,
	hMain,
	(HMENU)EV_BUTTONDOWN, hinstance, NULL);

    if ((hBitmapButtonCenter = (HBITMAP)LoadImage(NULL, "arrow_center.bmp",
	IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION|LR_DEFAULTSIZE|LR_LOADFROMFILE )) == NULL)
	MessageBox(hMain, "LoadImage failed!", "Debug", MB_OK);

    if ((hBitmapButtonCenterSel = (HBITMAP)LoadImage(NULL, "arrow_center_sel.bmp",
	IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION|LR_DEFAULTSIZE|LR_LOADFROMFILE )) == NULL)
	MessageBox(hMain, "LoadImage failed!", "Debug", MB_OK);

    if ((hBitmapButtonRight     = (HBITMAP)LoadImage(NULL, "arrow_right.bmp",
	IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION|LR_DEFAULTSIZE|LR_LOADFROMFILE )) == NULL)
	MessageBox(hMain, "LoadImage failed!", "Debug", MB_OK);

    if ((hBitmapButtonRightSel  = (HBITMAP)LoadImage(NULL, "arrow_right_sel.bmp",
	IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION|LR_DEFAULTSIZE|LR_LOADFROMFILE )) == NULL)
	MessageBox(hMain, "LoadImage failed!", "Debug", MB_OK);

    if ((hBitmapButtonLeft      = (HBITMAP)LoadImage(NULL, "arrow_left.bmp",
	IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION|LR_DEFAULTSIZE|LR_LOADFROMFILE )) == NULL)
	MessageBox(hMain, "LoadImage failed!", "Debug", MB_OK);

    if ((hBitmapButtonLeftSel   = (HBITMAP)LoadImage(NULL, "arrow_left_sel.bmp",
	IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION|LR_DEFAULTSIZE|LR_LOADFROMFILE )) == NULL)
	MessageBox(hMain, "LoadImage failed!", "Debug", MB_OK);

    if ((hBitmapButtonUp        = (HBITMAP)LoadImage(NULL, "arrow_up.bmp",
	IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION|LR_DEFAULTSIZE|LR_LOADFROMFILE )) == NULL)
	MessageBox(hMain, "LoadImage failed!", "Debug", MB_OK);

    if ((hBitmapButtonUpSel     = (HBITMAP)LoadImage(NULL, "arrow_up_sel.bmp",
	IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION|LR_DEFAULTSIZE|LR_LOADFROMFILE )) == NULL)
	MessageBox(hMain, "LoadImage failed!", "Debug", MB_OK);

    if ((hBitmapButtonDown      = (HBITMAP)LoadImage(NULL, "arrow_down.bmp",
	IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION|LR_DEFAULTSIZE|LR_LOADFROMFILE )) == NULL)
	MessageBox(hMain, "LoadImage failed!", "Debug", MB_OK);

    if ((hBitmapButtonDownSel   = (HBITMAP)LoadImage(NULL, "arrow_down_sel.bmp",
	IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION|LR_DEFAULTSIZE|LR_LOADFROMFILE )) == NULL)
	MessageBox(hMain, "LoadImage failed!", "Debug", MB_OK);

    return 0;
}


BOOL LoadBitmapFromBMPFile( LPTSTR szFileName, HBITMAP *phBitmap, HPALETTE *phPalette )
{
   BITMAP  bm;

   *phBitmap = NULL;
   *phPalette = NULL;

   // Use LoadImage() to get the image loaded into a DIBSection
   *phBitmap = (HBITMAP)LoadImage( NULL, szFileName, IMAGE_BITMAP, 0, 0,
               LR_CREATEDIBSECTION | LR_DEFAULTSIZE | LR_LOADFROMFILE );
   if( *phBitmap == NULL )
     return FALSE;

   // Get the color depth of the DIBSection
   GetObject(*phBitmap, sizeof(BITMAP), &bm );
   // If the DIBSection is 256 color or less, it has a color table
   if( ( bm.bmBitsPixel * bm.bmPlanes ) <= 8 )
   {
   HDC           hMemDC;
   HBITMAP       hOldBitmap;
   RGBQUAD       rgb[256];
   LPLOGPALETTE  pLogPal;
   WORD          i;

   // Create a memory DC and select the DIBSection into it
   hMemDC = CreateCompatibleDC( NULL );
   hOldBitmap = (HBITMAP)SelectObject( hMemDC, *phBitmap );
   // Get the DIBSection's color table
   GetDIBColorTable( hMemDC, 0, 256, rgb );
   // Create a palette from the color tabl
   pLogPal = (LOGPALETTE *)malloc( sizeof(LOGPALETTE) + (256*sizeof(PALETTEENTRY)) );
   pLogPal->palVersion = 0x300;
   pLogPal->palNumEntries = 256;
   for(i=0;i<256;i++)
   {
     pLogPal->palPalEntry[i].peRed = rgb[i].rgbRed;
     pLogPal->palPalEntry[i].peGreen = rgb[i].rgbGreen;
     pLogPal->palPalEntry[i].peBlue = rgb[i].rgbBlue;
     pLogPal->palPalEntry[i].peFlags = 0;
   }
   *phPalette = CreatePalette( pLogPal );
   // Clean up
   free( pLogPal );
   SelectObject( hMemDC, hOldBitmap );
   DeleteDC( hMemDC );
   }
   else   // It has no color table, so use a halftone palette
   {
   HDC    hRefDC;

   hRefDC = GetDC( NULL );
   *phPalette = CreateHalftonePalette( hRefDC );
   ReleaseDC( NULL, hRefDC );
   }
   return TRUE;

}


LRESULT CALLBACK WndProc (HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
    HDC hdcMem; 
    LPDRAWITEMSTRUCT lpdis;


    switch (Msg)
    {
        case WM_COMMAND:
	    if (wParam == IDOK || wParam == IDCANCEL) 
            { 
                // EndDialog(hDlg, TRUE); 
                return TRUE; 
            } 
            if (HIWORD(wParam) == BN_CLICKED) 
            { 
                switch (LOWORD(wParam)) 
                { 
                    case EV_BUTTONRIGHT: 
			//MessageBox(hWnd, "-right-", "Debug", MB_OK);
                        break; 

                    case EV_BUTTONLEFT: 
			//MessageBox(hWnd, "-left-", "Debug", MB_OK);
                        break; 

                    case EV_BUTTONUP: 
			//MessageBox(hWnd, "-up-", "Debug", MB_OK);
                        break; 

                    case EV_BUTTONDOWN: 
			//MessageBox(hWnd, "-down-", "Debug", MB_OK);
                        break; 

                    case EV_BUTTONCENTER: 
			//MessageBox(hWnd, "-center-", "Debug", MB_OK);
                        break; 
                } 
            } 
	    return 0;
		
	case WM_DRAWITEM:
	    lpdis = (DRAWITEMSTRUCT*)lParam;

	    if (lpdis->hwndItem == ButtonCenter)
	    {
	       ChangeButton(lpdis, hBitmapButtonCenter, hBitmapButtonCenterSel);

		return TRUE; 
	    }
	    if (lpdis->hwndItem == ButtonRight)
	    {
	       ChangeButton(lpdis, hBitmapButtonRight, hBitmapButtonRightSel);

		return TRUE; 
	    }
	    if (lpdis->hwndItem == ButtonDown)
	    {
	       ChangeButton(lpdis, hBitmapButtonDown, hBitmapButtonDownSel);

		return TRUE; 
	    }
	    if (lpdis->hwndItem == ButtonUp)
	    {
	       ChangeButton(lpdis, hBitmapButtonUp, hBitmapButtonUpSel);

		return TRUE; 
	    }
	    if (lpdis->hwndItem == ButtonLeft)
	    {
	       ChangeButton(lpdis, hBitmapButtonLeft, hBitmapButtonLeftSel);

		return TRUE; 
	    }
	    return 0;
	
	case WM_DESTROY:
	    PostQuitMessage(0);
	    exit(0);

	default:
	    return DefWindowProc(hWnd, Msg, wParam, lParam);
    }
}


int ChangeButton(LPDRAWITEMSTRUCT lpdis, HBITMAP hButton, HBITMAP hButtonSel)
{

    HDC hdc = CreateCompatibleDC(lpdis->hDC);

    if (lpdis->itemState & ODS_SELECTED)
	    SelectObject(hdc, hButtonSel);
    else
	    SelectObject(hdc, hButton);

    StretchBlt(lpdis->hDC,
	       lpdis->rcItem.left,
	       lpdis->rcItem.top,
	       lpdis->rcItem.right  - lpdis->rcItem.left,
	       lpdis->rcItem.bottom - lpdis->rcItem.top,
	       hdc,0,0,200,200,SRCCOPY);

    DeleteDC(hdc);

    return 0;
}

