#pragma hdrstop 
//--------------------------------------------------------------------------- 
#include <stdio.h> 
#include <windows.h> 
#include <mbstring.h> 
#include <string> 
#include <vector> 
#include <algorithm>
using namespace std; 
//--------------------------------------------------------------------------- 
#define VERSION "1.01 (2000-12)" 
//--------------------------------------------------------------------------- 
void long_to_short(string& s, int range); 
string extract_file_ext(const string& filename); 
bool find_dir(const string& dirname); 

typedef struct _FileSearch_ { 
    string name; 
    string long_name; 
    WORD wYear; 
    WORD wMonth; 
    WORD wDay; 
    WORD wHour; 
    WORD wMinute; 
    WORD wSecond; 
    string attr; 
    double filesize; 

    //constructer 
    _FileSearch_() { comp_mode = 1; long_name = ""; } 

    //operator 
    unsigned char comp_mode; 
    friend bool operator<(const _FileSearch_ &x, const _FileSearch_ &y) 
    { 
           if (x.comp_mode != y.comp_mode) return x.name < y.name; 

           if (x.comp_mode == 1) { // 
             return x.name < y.name; 

           } else if (x.comp_mode == 2) { // 
             if (x.wYear == y.wYear) { 
                if (x.wMonth == y.wMonth) { 
                   if (x.wDay == y.wDay) { 
                      if (x.wHour == y.wHour) { 
                         if (x.wMinute == y.wMinute) { 
                            return x.wSecond < y.wSecond; 
                          } else return x.wMinute < y.wMinute; 
                       } else return x.wHour < y.wHour; 
                    } else return x.wDay < y.wDay; 
                 } else return x.wMonth < y.wMonth; 
              } else return x.wYear < y.wYear; 

           } else if (x.comp_mode == 3) { // 
           return x.attr < y.attr;  

           } else if (x.comp_mode == 4) { // 
           return x.filesize < y.filesize; 

           } else if (x.comp_mode == 5) { // 
           return (x.long_name.empty() ? extract_file_ext(x.name) : extract_file_ext(x.long_name)) 
                              < 
                     (y.long_name.empty() ? extract_file_ext(y.name) : extract_file_ext(y.long_name)); 

           } 
           return x.name < y.name; 
    } 
} FileSearch; 
  

//--------------------------------------------------------------------------- 
//    
//--------------------------------------------------------------------------- 
#pragma argsused 
int main(int argc, char* argv[]) 
{ 
    vector<FileSearch> fsl; 
    string find_file = "*"; 

    bool _F = false; 
    bool _f = false; 
    bool _d = false; 
    bool _on = false; 
    bool _od = false; 
    bool _oa = false; 
    bool _os = false; 
    bool _oe = false; 

    if (argc < 2) { 
       //none 
    } else { 
       for (int i=1; i<argc; i++) { 
           if (strcmp(argv[i], "-F") == 0) { 
              // -F 
               _F = true; 
             } else if (strcmp(argv[i], "-h") == 0 || strcmp(argv[i], "-?") == 0) { 
              // -h 
               printf("<< ls ef command help >>\n"); 
               printf("  ls ef shows all files in current folder quickly.\n\n"); 

               printf("-- COMMAND --\n"); 
               printf("  ls [subfolder] [optoins] \n\n"); 

               printf("-- OPTIONS --\n"); 
               printf("  Opt  : Explanation\n"); 
               printf("  -----+------------------------------------\n"); 
               printf("  -F   : more property show.\n"); 
               printf("  -f   : file only show.\n"); 
               printf("  -d   : folder only show.\n"); 
               printf("  -----+------------------------------------\n"); 
               printf("  -on  : sort by name show.\n"); 
               printf("  -od  : sort by date show.\n"); 
               printf("  -oa  : sort by attribute show.\n"); 
               printf("  -os  : sort by size show.\n"); 
               printf("  -oe  : sort by extention show.\n"); 
               printf("  -----+------------------------------------\n"); 
               printf("  -h/? : option help show.\n"); 
               printf("  -v   : ls version show.\n"); 
             return 0; 
             } else if (strcmp(argv[i], "-v") == 0) { 
              // -v 
               printf("ls ef %s for Win32  by efs\n", VERSION); 
             return 0; 
             } else if (strcmp(argv[i], "-f") == 0) { 
              // -f 
               _f = true; 
             } else if (strcmp(argv[i], "-d") == 0) { 
              // -d 
               _d = true; 
             } else if (strcmp(argv[i], "-on") == 0) { 
              // -on 
              _on = true; 
             } else if (strcmp(argv[i], "-od") == 0) { 
              // -od 
               _od = true; 
             } else if (strcmp(argv[i], "-oa") == 0) { 
              // -oa 
               _oa = true; 
             } else if (strcmp(argv[i], "-os") == 0) { 
              // -os 
               _os = true; 
             } else if (strcmp(argv[i], "-oe") == 0) { 
              // -oe 
               _oe = true; 
           } else { 
             if (find_dir(string(argv[i]))) { 
                 find_file = string(argv[i]) + "\\*";  //_sbdir = true;  
              } else { 
                 printf("\"%s\" option is not found.\n",argv[i]); 
                 printf("\"-h\" or \"-\?\" option will show command help\n"); 
                 return 1; 
              } 
           } 
       } 
    } 

//2  
    WIN32_FIND_DATA wfd; 
    HANDLE h = FindFirstFile(find_file.c_str(), &wfd); 

    if ( h != INVALID_HANDLE_VALUE ) { 
       // 

       // 
       do { 
          //var 
          FileSearch fs; 

          //5  
          if (_on)      fs.comp_mode = 1; 
          else if (_od) fs.comp_mode = 2; 
          else if (_oa) fs.comp_mode = 3; 
          else if (_os) fs.comp_mode = 4; 
          else if (_oe) fs.comp_mode = 5; 

          // 
          fs.name = wfd.cFileName; 
          if (fs.name == "." || fs.name == "..") { 
              fs.name = "/" + fs.name; 
           if (wfd.nFileSizeLow == 0) { 
                 fs.attr = "DIRECTORY"; 
                 fsl.push_back(fs); 
               continue; 
              } 
          } 

          //Name 
          fs.name = wfd.dwFileAttributes == FILE_ATTRIBUTE_DIRECTORY ? "/" : ""; 
          fs.name = fs.name + wfd.cFileName; 
          if (_F) { 
             fs.long_name = fs.name; 
             long_to_short(fs.name, 21); 
          } else if (fs.name.length() > 17) { 
             fs.long_name = fs.name; 
             long_to_short(fs.name, 17); 
          } 

          // -F  
          if (_F || _f || _d || _on || _od || _oa || _os) { 
            //1 
            static char *attr_tbl[] = { 
                     "ARCHIVE", "DIRECTORY", "HIDDEN", "NORMAL", 
                     "READONLY", "SYSTEM", "TEMPORARY", "UNKNOWN" 
             }; 
             int attr_num = 7; 
             switch (wfd.dwFileAttributes) { 
               case FILE_ATTRIBUTE_ARCHIVE:   attr_num = 0; break; 
               case FILE_ATTRIBUTE_DIRECTORY: attr_num = 1; break; 
               case FILE_ATTRIBUTE_HIDDEN:    attr_num = 2; break; 
               case FILE_ATTRIBUTE_NORMAL:    attr_num = 3; break; 
               case FILE_ATTRIBUTE_READONLY:  attr_num = 4; break; 
               case FILE_ATTRIBUTE_SYSTEM:    attr_num = 5; break; 
               case FILE_ATTRIBUTE_TEMPORARY: attr_num = 6; break; 
             } 

            //2 
             SYSTEMTIME st; 
            if (!FileTimeToSystemTime(&wfd.ftLastWriteTime, &st)) { 
                 printf("error \n"); 
                continue; 
             } 

            //3 
             fs.wYear   = st.wYear; 
             fs.wMonth  = st.wMonth; 
             fs.wDay    = st.wDay; 
             fs.wHour   = st.wHour; 
             fs.wMinute = st.wMinute; 
             fs.wSecond = st.wSecond; 
             fs.attr    = attr_tbl[attr_num]; 

            //4 
             fs.filesize = (double)wfd.nFileSizeHigh * 0x100000000 + (double)wfd.nFileSizeLow; 
          } 

          // 
          fsl.push_back(fs); 

       } while ( FindNextFile(h, &wfd) ); 

       // 
       FindClose(h); 

    } else { 
       // 
       printf("File Search Error !\n"); 
       return 1; 
    } 

//3  
    sort( fsl.begin(), fsl.end() ); 

//4   
    const int fsl_length = (int) fsl.size(); 
    int file_article = fsl_length; 
    double file_size_total = 0; 
    for (int i=0,a=0; i<fsl_length; i++,a++) { 
        if (_F) { 
           // -F Option 
           if (fsl[i].name == "/." || fsl[i].name == "/..") { 
              printf("%21.21s\n", fsl[i].name.c_str()); 
              file_article--; 
           } else { 
              printf( "%21.21s  %4.4d%2.2d%2.2d  %2.2d%2.2d%2.2d  %-9.9s",  
                        fsl[i].name.c_str(), 
                        fsl[i].wYear, fsl[i].wMonth, fsl[i].wDay, fsl[i].wHour, fsl[i].wMinute, fsl[i].wSecond, 
                        fsl[i].attr.c_str() ); 
           if (fsl[i].attr == "DIRECTORY") { 
                  file_article--; 
                  printf("\n"); 
              } else { 
               double size = fsl[i].filesize / 1024; 
                 size = size != 0 && size < 1 ? 1 : size; 
                 file_size_total += size; 
                 printf("  %9.0f kByte\n", size); 
              } 
           } 
        } else { 
           // -f / -d Option 
           if (_f) { 
           if (fsl[i].attr == "DIRECTORY") { a--; continue; } 
           } else if (_d) { 
           if (fsl[i].attr != "DIRECTORY") { a--; continue; } 
           } 

           // Normal Output 
           printf("  %-17.17s", fsl[i].name.c_str()); 
           if (a == 3) { 
              printf("\n"); 
              a = -1; 
           } 
        } 
    } 

//5 -F  
    if (_F) { 
       // -F Option 
       char files[] = "", 
                dirs[]  = ""; 
       printf("  %21.21s  %d   %-.0f k\n", files, file_article, file_size_total); 
       printf("  %21.21s  %d\n", dirs,  (fsl_length - file_article)); 
    } 

//return 
    return 0; 

} //main 
//--------------------------------------------------------------------------- 
  

//--------------------------------------------------------------------------- 
//    
//--------------------------------------------------------------------------- 
// 
//Ex.      abcdefd.test -->  abc~test         by long_to_short("abcdefd.test", 8) 
void long_to_short(string& s, int range) 
{ 
     // 
     if ( (int)s.length() <= range) return; 
     // 
     int ext_length = s.length() - s.find_last_of('.', s.length()-1) - 1; 
     if (ext_length <= 0 || (int)s.length() <= ext_length || range-2 <= ext_length) return; 
     // 
     int front_len  = range - ext_length - 1, 
           back_start = s.length() - ext_length, 
           back_len   = ext_length; 
     if (_ismbblead(s[front_len-1])) { 
        if (_ismbbtrail(s[front_len-1])) { 
           // 
           // 
           if (!_ismbblead(s[front_len>=2 ? front_len-2 : 0]) && _ismbbtrail(s[front_len])) 
              front_len--; 
        } else { 
           front_len--; 
        } 
     } 
     // 
     s = s.substr(0, front_len) + "~" + s.substr(back_start, back_len); 
} 
//--------------------------------------------------------------------------- 
// 
string extract_file_ext(const string& filename) 
{ 
     int ext_start = filename.find_last_of('.', filename.length() - 1) + 1; 
     if (ext_start == (int)filename.length()) 
        return filename; 
    else 
        return filename.substr(ext_start, filename.length() - ext_start); 
} 
//--------------------------------------------------------------------------- 
// 
bool find_dir(const string& dirname) 
{ 
     return GetFileAttributes(dirname.c_str()) == FILE_ATTRIBUTE_DIRECTORY; 
} 
//--------------------------------------------------------------------------- 


