#pragma hdrstop 

#include "stdafx.h"
#include <windows.h> 
#include <oledlg.h>
#include "wmp.h"
#include <comutil.h>
#include <commctrl.h>

#include <mbstring.h> 
#include <string> 
#include <vector> 
#include <algorithm>
#include <functional>

using namespace std; 

//*********************************************************************
//* To interface the play.cpp
//*********************************************************************
extern int     check_extension(char * filename);
extern int     InsertTreeItem(HWND hTreeView, HTREEITEM hParent,
				 char * buffer, int icon);
extern HWND hTreeView;

#define ICON_FOLDER	    0
#define ICON_MUSIC	    1

#define SORTBYNAME	1
#define SORTBYDATE	2
#define SORTBYREVDATE	3

extern int SortType;
//*********************************************************************



typedef struct _FileSearch_ { 
    string name; 
    WORD wYear; 
    WORD wMonth; 
    WORD wDay; 
    WORD wHour; 
    WORD wMinute; 
    WORD wSecond; 
    int  attr;

    //constructer 
    _FileSearch_() { comp_mode = 1; }

    unsigned char comp_mode; 

    //operator 
    friend bool operator<(const _FileSearch_ &x, const _FileSearch_ &y) 
    { 
	if (x.comp_mode != y.comp_mode) return x.name < y.name; 

	if (x.comp_mode == 1) 
	{
            int i;
            string x1, y1;

            x1 = x.name;
            y1 = y.name;

	    for (i = 0; i < x1.size(); i++)
		x1[i] = tolower(x1[i]);

	    for (i = 0; i < y1.size(); i++)
		y1[i] = tolower(y1[i]);

	    return x1 < y1; 
	    // return x.name < y.name; 
	}
	else if (x.comp_mode == 2) 
	{
	    if (x.wYear == y.wYear) 
	    { 
		if (x.wMonth == y.wMonth) 
		{ 
		    if (x.wDay == y.wDay) 
		    { 
			if (x.wHour == y.wHour) 
			{ 
			    if (x.wMinute == y.wMinute) 
			    { 
				return x.wSecond < y.wSecond; 
			    }
			    else return x.wMinute < y.wMinute; 
			}
			else return x.wHour < y.wHour; 
		    }
		    else return x.wDay < y.wDay; 
		}
		else return x.wMonth < y.wMonth; 
	    }
	    else return x.wYear < y.wYear; 
	}
	else if (x.comp_mode == 3) 
	{
	    if (x.wYear == y.wYear) 
	    { 
		if (x.wMonth == y.wMonth) 
		{ 
		    if (x.wDay == y.wDay) 
		    { 
			if (x.wHour == y.wHour) 
			{ 
			    if (x.wMinute == y.wMinute) 
			    { 
				return x.wSecond > y.wSecond; 
			    }
			    else return x.wMinute > y.wMinute; 
			}
			else return x.wHour > y.wHour; 
		    }
		    else return x.wDay > y.wDay; 
		}
		else return x.wMonth > y.wMonth; 
	    }
	    else return x.wYear > y.wYear; 
	}
        return x.name < y.name; 
    }

} FileSearch; 


int GetList(HTREEITEM hParent, char * path)
{
    vector<FileSearch> fsl; 

    string find_file = "*"; 

    bool _od = true; 

    WIN32_FIND_DATA wfd; 


    SetErrorMode(SEM_FAILCRITICALERRORS);

    HANDLE h = FindFirstFile(path, &wfd); 

    if ( h == INVALID_HANDLE_VALUE ) 
    { 
       printf("File Search Error !\n"); 
       return 1; 
    } 
    do 
    { 
	FileSearch fs; 

	fs.name = wfd.cFileName; 

	if (fs.name == "." || fs.name == "..")
	    continue;

        fs.attr = wfd.dwFileAttributes;

fs.comp_mode = SortType;
/*
	if ((fs.attr == 16) || (fs.attr == 17))
	    fs.comp_mode = 3; 
	else
	    fs.comp_mode = 1; 
*/

	SYSTEMTIME st; 

	if (!FileTimeToSystemTime(&wfd.ftLastWriteTime, &st)) 
	{ 
	    printf("error \n"); 
	    continue; 
	} 
	fs.wYear   = st.wYear; 
	fs.wMonth  = st.wMonth; 
	fs.wDay    = st.wDay; 
	fs.wHour   = st.wHour; 
	fs.wMinute = st.wMinute; 
	fs.wSecond = st.wSecond; 

        fsl.push_back(fs); 

    } while ( FindNextFile(h, &wfd) ); 

    FindClose(h); 

    sort( fsl.begin(), fsl.end() ); 

    const int fsl_length = (int) fsl.size(); 

    for (int i=0,a=0; i<fsl_length; i++,a++) 
    { 
        //printf("  %s\n", fsl[i].name.c_str()); 

	char * ptr = (char *)fsl[i].name.c_str();

	if ((fsl[i].attr == 16) ||
	    (fsl[i].attr == 17))
	    InsertTreeItem(hTreeView, hParent, ptr, ICON_FOLDER);

	else if (check_extension(ptr) == 0)
	    InsertTreeItem(hTreeView, hParent, ptr, ICON_MUSIC);
    } 
    return 0; 
}
