


#if !defined(AFX_STDAFX_H__39694509_F4A0_11D1_9F80_006008984DF6__INCLUDED_)

#define AFX_STDAFX_H__39694509_F4A0_11D1_9F80_006008984DF6__INCLUDED_

// #if _MSC_VER >= 1000
// #pragma once
// #endif // _MSC_VER >= 1000

// #define VC_EXTRALEAN	// Exclude rarely-used stuff from Windows headers

#include <afxwin.h>         // MFC core and standard components
#include <afxext.h>         // MFC extensions
#ifndef _AFX_NO_AFXCMN_SUPPORT
#include <afxcmn.h>		// MFC support for Windows Common Controls
#endif // _AFX_NO_AFXCMN_SUPPORT

#include <mmsystem.h>

#endif 

int open_mixer();
int set_mixer(DWORD ComponentType);
int set_mute(long lval);
int get_mute(long * lVal);
int get_meter_init();

DWORD m_dwMuteControlID;
DWORD m_dwMeterControlID;
HMIXER m_hMixer;

void main()
{
    long lVal = 0;
    float fVal;

    open_mixer();

    // set_mixer(MIXERLINE_COMPONENTTYPE_DST_SPEAKERS);
    set_mixer(MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT);

    get_meter_init();


    get_mute(&lVal);

    printf("see %ld\n", lVal);

    fVal = lVal;

    printf("see %lf\n", (fVal / 65536));
    printf("see %3.0lf\n", (fVal / 65536) * 100);

    // if (lVal == 0l) lVal = 1l; else lVal = 0l;
    if (lVal == 0l) lVal = 30000l; else lVal = 0l;

    set_mute(lVal);

    mixerClose(m_hMixer);
}

int open_mixer()
{
   UINT m_nNumMixers;
   MIXERCAPS m_mxcaps;


   m_nNumMixers  = mixerGetNumDevs();

   m_hMixer = NULL;

   printf("MIxer number <%d>\n", m_nNumMixers);

   if (m_nNumMixers != 0)
   {
	if (mixerOpen(&m_hMixer, 0, 0, // reinterpret_cast<DWORD>(this->GetSafeHwnd()),
		    NULL, MIXER_OBJECTF_MIXER | CALLBACK_WINDOW) != MMSYSERR_NOERROR)
	{
		return FALSE;
	}

	if (mixerGetDevCaps(reinterpret_cast<UINT>(m_hMixer),
			  &m_mxcaps, sizeof(MIXERCAPS)) != MMSYSERR_NOERROR)
	{
		    return FALSE;
	}
    }
    return 0;
}

int get_mute(long * lVal)
{
    MIXERCONTROLDETAILS_BOOLEAN mxcdMute;
    MIXERCONTROLDETAILS mxcd;

    mxcd.cbStruct = sizeof(MIXERCONTROLDETAILS);
    mxcd.dwControlID = m_dwMuteControlID;
    mxcd.cChannels = 1;
    mxcd.cMultipleItems = 0;
    mxcd.cbDetails = sizeof(MIXERCONTROLDETAILS_BOOLEAN);
    mxcd.paDetails = &mxcdMute;

    if (mixerGetControlDetails(reinterpret_cast<HMIXEROBJ>(m_hMixer),
			     &mxcd, MIXER_OBJECTF_HMIXER | MIXER_GETCONTROLDETAILSF_VALUE)
		!= MMSYSERR_NOERROR)
    {
	return FALSE;
    }
    
    *lVal = mxcdMute.fValue;

    return 0;
}

int set_mute(long lVal)
{
    printf("set now\n");

    MIXERCONTROLDETAILS_BOOLEAN mxcdMute = { lVal };
    MIXERCONTROLDETAILS mxcd;

    mxcd.cbStruct = sizeof(MIXERCONTROLDETAILS);
    mxcd.dwControlID = m_dwMuteControlID;
    mxcd.cChannels = 1;
    mxcd.cMultipleItems = 0;
    mxcd.cbDetails = sizeof(MIXERCONTROLDETAILS);
    mxcd.paDetails = &mxcdMute;

    if (mixerSetControlDetails(reinterpret_cast<HMIXEROBJ>(m_hMixer),
							     &mxcd,
							     MIXER_OBJECTF_HMIXER |
							     MIXER_SETCONTROLDETAILSF_VALUE)
	    != MMSYSERR_NOERROR)
    {
	    return FALSE;
    }
    return 0;
}


int set_mixer(DWORD ComponentType)
{
    MIXERLINE mxl;

    mxl.cbStruct = sizeof(MIXERLINE);

    // mxl.dwComponentType = MIXERLINE_COMPONENTTYPE_DST_SPEAKERS;
    // mxl.dwComponentType = MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT;
    mxl.dwComponentType = ComponentType;

    if (mixerGetLineInfo(reinterpret_cast<HMIXEROBJ>(m_hMixer),
        &mxl,
        MIXER_OBJECTF_HMIXER |
        MIXER_GETLINEINFOF_COMPONENTTYPE) != MMSYSERR_NOERROR)
    {
	    return FALSE;
    }

    MIXERCONTROL mxc;
    MIXERLINECONTROLS mxlc;

    mxlc.cbStruct = sizeof(MIXERLINECONTROLS);
    mxlc.dwLineID = mxl.dwLineID;

    // mxlc.dwControlType = MIXERCONTROL_CONTROLTYPE_MUTE;
    mxlc.dwControlType = MIXERCONTROL_CONTROLTYPE_VOLUME;

    mxlc.cControls = 1;
    mxlc.cbmxctrl = sizeof(MIXERCONTROL);
    mxlc.pamxctrl = &mxc;

    if (mixerGetLineControls(reinterpret_cast<HMIXEROBJ>(m_hMixer),
        &mxlc,
	MIXER_OBJECTF_HMIXER |
        MIXER_GETLINECONTROLSF_ONEBYTYPE) != MMSYSERR_NOERROR)
    {
	printf("error from mixerGetLineControls\n");
        return FALSE;
    }

    printf("nam = <%s>\n", mxl.szName);
    printf("nam = <%s>\n", mxc.szName);

    m_dwMuteControlID = mxc.dwControlID;

    return 0;
}

int get_meter_init()
{
	if (m_hMixer == NULL)
	{
		printf("-1-\n");
		return FALSE;
	}

	// get the destination line
	MIXERLINE mxlDst;
	mxlDst.cbStruct = sizeof(MIXERLINE);
	mxlDst.dwComponentType = MIXERLINE_COMPONENTTYPE_DST_SPEAKERS;
	if (::mixerGetLineInfo(reinterpret_cast<HMIXEROBJ>(m_hMixer),
		                   &mxlDst,
			    		   MIXER_OBJECTF_HMIXER |
				    	   MIXER_GETLINEINFOF_COMPONENTTYPE)
		!= MMSYSERR_NOERROR)
	{
		
		printf("-2-\n");
		return FALSE;
	}

	// get dwLineID
	MIXERLINE mxl = { 0 };

	for (DWORD dwi = 0; dwi < mxlDst.cConnections; dwi++)
	{
		mxl.cbStruct = sizeof(MIXERLINE);
		mxl.dwDestination = mxlDst.dwDestination;
		mxl.dwSource = dwi;
		if (::mixerGetLineInfo(reinterpret_cast<HMIXEROBJ>(m_hMixer),
							   &mxl,
			    			   MIXER_OBJECTF_HMIXER |
				    		   MIXER_GETLINEINFOF_SOURCE)
			== MMSYSERR_NOERROR &&
			mxl.dwComponentType == MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT)
		{
			break;  // found
		}
	}

	if (dwi >= mxlDst.cConnections)
	{
		
		printf("-3-\n");
		return FALSE;  // not found
	}

	ASSERT(mxl.dwDestination == mxlDst.dwDestination &&
		   mxl.dwComponentType == MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT);

	// get dwControlID
	MIXERCONTROL mxc;
	MIXERLINECONTROLS mxlc;
	mxlc.cbStruct = sizeof(MIXERLINECONTROLS);
	mxlc.dwLineID = mxl.dwLineID;
	mxlc.dwControlType = MIXERCONTROL_CONTROLTYPE_PEAKMETER;
	mxlc.cControls = 1;
	mxlc.cbmxctrl = sizeof(MIXERCONTROL);
	mxlc.pamxctrl = &mxc;
	if (::mixerGetLineControls(reinterpret_cast<HMIXEROBJ>(m_hMixer),
		                       &mxlc,
			    			   MIXER_OBJECTF_HMIXER |
				    		   MIXER_GETLINECONTROLSF_ONEBYTYPE)
	    != MMSYSERR_NOERROR)
	{
		
		printf("-4-\n");
		return FALSE;
	}

	// store dwControlID
	// m_strWaveLineName = mxl.szName;
	// m_strMeterControlName = mxc.szName;
	// m_lMinimum = mxc.Bounds.lMinimum;
	// m_lMaximum = mxc.Bounds.lMaximum;
	m_dwMeterControlID = mxc.dwControlID;

	return 0;
}

int get_meter_value(LONG * lVal)
{
	if (m_hMixer == NULL)
	{
		printf("-5-\n");
		return FALSE;
	}

	MIXERCONTROLDETAILS_SIGNED mxcdMeter;
    MIXERCONTROLDETAILS mxcd;
	mxcd.cbStruct = sizeof(MIXERCONTROLDETAILS);
    mxcd.dwControlID = m_dwMeterControlID;
    mxcd.cChannels = 1;
    mxcd.cMultipleItems = 0;
    mxcd.cbDetails = sizeof(MIXERCONTROLDETAILS_SIGNED);
    mxcd.paDetails = &mxcdMeter;
	if (::mixerGetControlDetails(reinterpret_cast<HMIXEROBJ>(m_hMixer),
		                         &mxcd,
		                         MIXER_OBJECTF_HMIXER |
				    			 MIXER_GETCONTROLDETAILSF_VALUE)
		!= MMSYSERR_NOERROR)
	{
		
		printf("-6-\n");
		return FALSE;
	}
	
	*lVal = mxcdMeter.lValue;

	return 0;
}
